/*
Roman Yu. Toropov
*/

// LCD module connections
sbit LCD_RS at PORTA5_bit;
sbit LCD_EN at PORTA4_bit;
sbit LCD_D4 at PORTA3_bit;
sbit LCD_D5 at PORTA2_bit;
sbit LCD_D6 at PORTA1_bit;
sbit LCD_D7 at PORTA0_bit;

sbit LCD_RS_Direction at DDA5_bit;
sbit LCD_EN_Direction at DDA4_bit;
sbit LCD_D4_Direction at DDA3_bit;
sbit LCD_D5_Direction at DDA2_bit;
sbit LCD_D6_Direction at DDA1_bit;
sbit LCD_D7_Direction at DDA0_bit;
// End LCD module connections

// DAC module connections
sbit Select_DAC_Direction at DDA7_bit;
sbit Select_DAC at PORTA7_bit;
float measurement;
char measuremen[15];
unsigned int cycle;

void init_SPI() {
// Init SPI
  SPI1_Init_Advanced(_SPI_MASTER,                // Initialize AVR as master
                     _SPI_FCY_DIV16,             // Data sample at end
                     _SPI_CLK_LO_LEADING);

  Select_DAC_Direction = 1;
  Select_DAC = 1;
}

void set_DAC() {
  char temp;
  Select_DAC = 0;
  temp = (cycle >> 8);
  SPI1_Write(temp);
  temp = (cycle);
  SPI1_Write(temp);
  Select_DAC = 1;
}

void print_dac() {
  // Lcd_Cmd(_LCD_CLEAR);
  sprintf(measuremen,"%0.4f", measurement);
  Lcd_Out(1,1,measuremen);
  sprintf(measuremen,"%0.0u", cycle);
  Lcd_Out(2,1,measuremen);
}


void system_init() {
  init_SPI();
  Lcd_Init();                        // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);               // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
  Lcd_Out(1,5,"\x4D\x61\xBA\x65\xBF\xBA\x61");
  Lcd_Out(2,1,"ATmega128 16 MHz");
  Delay_ms(1900);
}


void main() {
  system_init();
  Lcd_Cmd(_LCD_CLEAR);
  cycle = 0;
  measurement=0.0001; // Volts
  cycle = measurement * 16000; // Dec
     while(1){
       // Lcd_Cmd(_LCD_CLEAR);               // Clear display
       set_DAC();
       // cycle++;
       measurement = measurement + 0.0001;
       cycle = measurement * 16000;
       if (cycle > 65535) {measurement=0; Lcd_Cmd(_LCD_CLEAR); Delay_ms(900); }
       print_dac();
       Delay_ms(500);
     }


}